//use storage::BlockFile;
use storage::*;

#[tokio::main]
async fn main()
{
    std::fs::create_dir_all("data").ok();

    /*let op = 0;
    if let Ok(mut bf) = BlockFile::<32>::open("data/cache_data.bin").await {
        match op {
            0 => {
                for i in 0..1 {
                    if let Ok(id) = bf.insert(format!("{} This is a test of the block file system {}.", i, i).as_bytes()).await {
                        let data = String::from_utf8(bf.get(id).await.unwrap()).unwrap();
                        println!("id {} = '{}'", id, data);
                    }
                }
            }
            1 => {
                bf.remove(12).await.ok();
            }
            _ => { }
        }
    } else {
        println!("Failed to open.");
    }*/

    if let Ok(mut tf) = TrieFile::<8>::open("data/cache_index.bin").await {

        for s in [
            "Hello",
            "Hello!",
            "Goodbye",
            "Greatings",
            "Good day",
            "Regards",
        ] {
            println!("# insert {}", s);
            if tf.set(s.as_bytes(), s.as_bytes()).await.is_err() {
                println!("Failed to insert '{}'.", s);
            }

            if let Ok(Some(id)) = tf.find(s.as_bytes()).await {
                println!("found '{}'.", id);

                if let Ok(key) = tf.key(id).await {
                    println!(" > '{}'", String::from_utf8(key).unwrap());
                }

                if let Ok(Some(data)) = tf.get(id).await {
                    println!(" = '{}'", String::from_utf8(data).unwrap());
                }
            }
            println!("");
        }

        for i in tf.ids().await.unwrap() {
            println!("id {}", i);

            if let Ok(key) = tf.key(i).await {
                println!(" > '{}'", String::from_utf8(key).unwrap());
            }

            if let Ok(Some(data)) = tf.get(i).await {
                println!(" = '{}'", String::from_utf8(data).unwrap());
            }
            println!("");
        }

    } else {
        println!("Failed to open index.");
    }
}
